/*
 * File AD_Tp112.h (Tp112 specific constants)
 */

#ifndef __AD_TP112_H
#define __AD_TP112_H


/*
 * System include files
 */
#include "_defs.h"

/*
 * Custom include files
 */
#include "const.h"
#include "types.h"


/*
 * Wait after switching PGA
 */
#define PGA_SWITCHINGTIME	     10

/*
 * Values for the CONTROL registers in CONTROL REGISTER 1
 */
#define POST_LO_CON		0
#define POST_HI_CON		1
#define OUTPUT_CON              2
#define TIMEBASE_CON		3
#define MODE_CON		4
#define RESET_CON		5
#define COUNT_CON		6
#define WRITE_TIMEBASE_CON	7

/*
 * Values for the CONTROL registers in CONTROL REGISTER 2 and 3
 */
#define LEVEL1_CON		0
#define LEVEL2_CON		1
#define TRIGNIV_CON             2
#define PGA_CON 		3
#define DATAZERO_CON		4
#define IRQ_CON 		5
#define TRIGRESET_CON		6

#define COUPLEAC		TRUE
#define COUPLEDC		FALSE


/*
 * Possible input voltages
 */
#define PGA1250MVOLT		 0
#define PGA2500MVOLT		 1
#define PGA5VOLT		 2
#define PGA10VOLT		 3
#define PGA20VOLT		 4

extern int   Ad_PortAddress;
extern BYTE  Ch_Switch_Value[NUMCHANNELS][5];

#endif