/*
 * File AD_Tp508.h (Tp508 specific constants)
 */

#ifndef __AD_TP508_H
#define __AD_TP508_H


/*
 * System include files
 */
#include "_defs.h"

/*
 * Custom include files
 */
#include "const.h"
#include "types.h"


/*
 * Register setting-possibilities
 */
#define PGA_SWITCHINGTIME	     3 // Wait 5 msec after switching PGA
#define PGA1_GAIN_2     	           2
#define PGA1_GAIN_1		           4
#define PGA1_GAIN_1_10		           8
#define PGA2_GAIN_1_10  	          16
#define PGA2_GAIN_1     	          32
#define PGA2_GAIN_2     	          64
#define PGA2_GAIN_4     	         128
#define PGA2_ON         	         256
#define PGA1_ON         	         512
#define PGA1_GAIN_4     	        1024
#define PGA1_ATT_10     	        2048
#define PGA1_ATT_1      	        4096
#define PGA1_AC_DC      	        8192
#define PGA2_AC_DC      	       16384L
#define PGA2_ATT_1      	       32768L
#define PGA2_ATT_10     	       65536L
#define PGA2_ATT_100    	      131072L
//#define ???           	      262144L (NOG LEEG)
#define REF_ON			      524288L
#define PGA1_ATT_100    	     1048576L

/*
 * Values for the CONTROL register
 */
#define POST_LO_CON		0
#define POST_HI_CON		1
#define TIMEBASE_CON		2
#define MODE_CON		3
#define RESET_CON		4
#define COUNT_CON		5
#define WRITE_TIMEBASE_CON	6

#define COUPLEAC		TRUE
#define COUPLEDC		FALSE


/*
 * Possible input voltages
 */
#define PGA20MVOLT		 0
#define PGA40MVOLT		 1
#define PGA80MVOLT		 2
#define PGA200MVOLT		 3
#define PGA400MVOLT		 4
#define PGA800MVOLT		 5
#define PGA2VOLT		 6
#define PGA4VOLT		 7
#define PGA8VOLT		 8
#define PGA20VOLT		 9
#define PGA40VOLT		10
#define PGA80VOLT		11


extern int      Ad_PortAddress;
extern BYTE     Ref_Value[NUMCHANNELS][15];
extern float    DA_Value[NUMCHANNELS][15];
extern float    Offset_AD[NUMCHANNELS];
extern long int Ch_Switch_Value[NUMCHANNELS][15];

#endif