{-------------------------------- TIMER --------------------------------------}
procedure TimeOutTimer;
interrupt;
begin
  inc(TimerCount);
end;{TimeOutTimer}

{*****************************************************************************}
{************************    ProgramExit *************************************}
{*****************************************************************************}
procedure ProgramExit;
begin
  exitproc:=exitsave;
  setintvec($1c,Int1cSave);
  port[Tp208AddressMaster+4]:=3;
  port[Tp208AddressMaster+5]:=0;
  port[Tp208AddressSlave1+4]:=3;
  port[Tp208AddressSlave1+5]:=0;
end;{ProgramExit}


{*****************************************************************************}
{******************** SetRef *************************************************}
{*****************************************************************************}
procedure SetRef(value1,value2,IoAddress:integer);
const PgaBlnk=64;
      RefSlct=32;
var SerialClck : byte;
    SerialData : byte;
    Help       : word;
    i          : integer;
    Data       : integer;
   Tp208Address: word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  port[Tp208Address+4]:=3;
  Help:=128;
  SerialData:=0;
  SerialClck:=0;
  port[Tp208Address+5]:=SerialData+SerialClck+PgaBlnk;
  port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
  SerialClck:=2;
  port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;

  for i:=1 to 8 do
  begin
    if (value1 and Help)=0 then SerialData:=0
                           else SerialData:=1;
    SerialClck:=0;
    port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
    SerialClck:=2;
    port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
    Help:=Help div 2;
  end;
  Help:=128;
  for i:=1 to 8 do
  begin
    if (value2 and Help)=0 then SerialData:=0
                           else SerialData:=1;
    SerialClck:=0;
    port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
    SerialClck:=2;
    port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
    Help:=Help div 2;
  end;
  SerialData:=0;
  SerialClck:=0;
  port[Tp208Address+5]:=SerialData+SerialClck+RefSlct+PgaBlnk;
  port[Tp208Address+5]:=PgaBlnk;
end;{SetRef}


{*****************************************************************************}
{******************** SetPga ************************************************}
{*****************************************************************************}
procedure SetPga(AcDc1,AcDc2:boolean;value:longint;IoAddress:integer);
const PgaBlnk=64;
      PgaSlct=16;

var SerialClck,
    SerialData   : byte;
    Help         : longint;
    i,
    Data         : integer;
    Tp208Address : word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  if not(AcDc1) then value:=value+Pga1AcDc ;
  if not(AcDc2) then value:=value+Pga2AcDc ;
  port[Tp208Address+4]:=3;
  Help:=round(exp(20*ln(2)));;
  SerialClck:=0;
  SerialData:=0;
  port[Tp208Address+5]:=SerialData+SerialClck+PgaBlnk;
  for i:=1 to 20 do
  begin
    if (value and Help)=0 then SerialData:=0
                          else SerialData:=1;
    SerialClck:=0;
    port[Tp208Address+5]:=SerialData+SerialClck+PgaBlnk;
    SerialClck:=2;
    port[Tp208Address+5]:=SerialData+SerialClck+PgaBlnk;
    Help:=Help div 2;
  end;
  port[Tp208Address+5]:=PgaSlct+PgaBlnk;
  port[Tp208Address+5]:=PgaBlnk;
  delay(PgaSwitchTime);
end;{SetPga}


{*****************************************************************************}
{******************** SetDa **************************************************}
{*****************************************************************************}
procedure SetDa(ChNumber:integer;value:real;IoAddress:integer);
const PgaBlnk    = 64;
      AdSlct     : array[1..2] of byte=(4,8);
var SerialClck   : byte;
    SerialData   : byte;
    Help         : word;
    i            : integer;
    Data         : integer;
    Tp208Address : word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  port[Tp208Address+4]:=3;
  value:=((value/5)*2048)+2048;
  if value>4095 then value:=4095;
  if value<0    then value:=0;
  Data:=round(value);
  Data:=Data xor 2048;
  Help:=32768;
  SerialClck:=2;
  SerialData:=0;
  port[Tp208Address+5]:=SerialData+SerialClck+AdSlct[ChNumber]+PgaBlnk;
  for i:=1 to 16 do
  begin
    if (Data and Help)=0 then SerialData:=0
                         else SerialData:=1;
    SerialClck:=2;
    port[Tp208Address+5]:=SerialData+SerialClck+AdSlct[ChNumber]+PgaBlnk;
    SerialClck:=0;
    port[Tp208Address+5]:=SerialData+SerialClck+AdSlct[ChNumber]+PgaBlnk;
    Help:=Help div 2;
  end;
  port[Tp208Address+5]:=PgaBlnk;
end;


{*****************************************************************************}
{******************** ReadEoc ************************************************}
{*****************************************************************************}
function ReadEoc(IoAddress:integer):boolean;
var Tp208Address : word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else         exit;
  end;
  ReadEoc:=(port[Tp208Address+2] and 1)=1;
end;{ReadEoc}


{*****************************************************************************}
{******************** SetPostCount  ******************************************}
{*****************************************************************************}
procedure SetPostCount(PostCount:word;IoAddress:integer);
var PostLoReg    : byte;
    PostHiReg    : byte;
    Tp208Address : word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  PostCount:=PostCount;
  PostLoReg:=lo(PostCount);
  PostHiReg:=hi(PostCount);
  port[Tp208Address+ContReg[1]]:=PostLoCon;
  port[Tp208Address+DataReg[1]]:=PostLoReg;
  port[Tp208Address+ContReg[1]]:=PostHiCon;
  port[Tp208Address+DataReg[1]]:=PostHiReg;
end;{SetPostCounter}


{*****************************************************************************}
{******************** SetTrigLevel *******************************************}
{*****************************************************************************}
procedure SetTriglevel(hel:boolean;level,hys,source:byte;IoAddress:integer);
var ChNumber     : byte;
    Help         : integer;
    Tp208Address : word;

  function Clip(Value:integer):integer;
  begin
    if Value>255 then Value:=255;
    if Value<0   then Value:=0;
    Clip:=Value;
  end;

begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  for ChNumber:=1 to 2 do
  begin
    if hel then
    begin
      Level1RegAd[ChNumber]:=Clip(level-hys);
      Level2RegAd[ChNumber]:=Clip(level);
      if source=ExtTrig then TrigLevelRegAd[ChNumber]:=0
                        else TrigLevelRegAd[ChNumber]:=5;
    end else
    begin
      Level1RegAd[ChNumber]:=Clip(level+hys);
      Level2RegAd[ChNumber]:=Clip(level);
      if source=ExtTrig then TrigLevelRegAd[ChNumber]:=2
                        else TrigLevelRegAd[ChNumber]:=6;
    end;
    port[Tp208Address+ContReg[ChNumber+1]]:=TrigLevelConAd[ChNumber];
    port[Tp208Address+DataReg[ChNumber+1]]:=TrigLevelRegAd[ChNumber];

    port[Tp208Address+ContReg[ChNumber+1]]:=Level1ConAd[ChNumber];
    port[Tp208Address+DataReg[ChNumber+1]]:=Level1RegAd[ChNumber];
    port[Tp208Address+ContReg[ChNumber+1]]:=Level2ConAd[ChNumber];
    port[Tp208Address+DataReg[ChNumber+1]]:=Level2RegAd[ChNumber];
  end;
end;{SetTriggerLevel}


{*****************************************************************************}
{******************** SetTrigBit    ******************************************}
{*****************************************************************************}
procedure SetTrigbit(IoAddress:integer);
var Tp208Address : word;

begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  port[Tp208Address]:=7;
  port[Tp208Address+1]:=2;
end;{SetTriggerBit}


{*****************************************************************************}
{******************** SetTimeBase ********************************************}
{*****************************************************************************}
procedure SetTimebase(var Freq:real;IoAddress:integer);
var DivisionFactor : word;
    InputFreq      : real;
    TimebaseReg    : byte;
    Tp208Address   : word;

begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  if Freq>20e6 then Freq:=20e6;
  if Freq<1e-3 then Freq:=1e-3;
  if Freq=20e6 then
  begin
    TimebaseReg:=0+32;
    port[Tp208Address+ContReg[1]]:=TimebaseCon;
    port[Tp208Address+DataReg[1]]:=TimebaseReg;
    exit;
  end;
  if Freq=10e6 then
  begin
    TimebaseReg:=4+32;
    port[Tp208Address+ContReg[1]]:=TimebaseCon;
    port[Tp208Address+DataReg[1]]:=TimebaseReg;
    exit;
  end;
  if Freq=4e6 then
  begin
    TimebaseReg:=8+32;
    port[Tp208Address+ContReg[1]]:=TimebaseCon;
    port[Tp208Address+DataReg[1]]:=TimebaseReg;
    exit;
  end;
  InputFreq:=4e6;
  { determine  DivisionFactor}
  if Freq>4000000 then Freq:=4000000;
  if Freq<62 then
  begin
    InputFreq:=4e4;
  end;
  DivisionFactor:=round(InputFreq/Freq);
  Freq:=InputFreq/DivisionFactor;

  {init timer IC 8254, control word A1,A0=11}
  TimebaseReg:=3+32;
  {activate timebase register}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;

  port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
  port[Tp208Address+DataReg[1]]:=54;
                                 {00  [=select counter 0]
                                  11  [=write least significant byte first]
                                  011 [=mode 3, divide by n counter]
                                  0   [=16-bits counter] }
  {load  division factor}
  TimebaseReg:=0+32;
  {activate the timebase register}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;
  port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
  port[Tp208Address+DataReg[1]]:=lo(DivisionFactor);
  port[Tp208Address+DataReg[1]]:=hi(DivisionFactor);

  if Freq<62 then
  begin
    {init the timer IC 8254, control word A1,A0=11}
    TimebaseReg:=3+32;
    {activate timebase register}
    port[Tp208Address+ContReg[1]]:=TimebaseCon;
    port[Tp208Address+DataReg[1]]:=TimebaseReg;

    port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
    port[Tp208Address+DataReg[1]]:=118;
                                   {01  [=select counter 1]
                                    11  [=write least significant byte first]
                                    011 [=mode 3, divide by n counter]
                                    0   [=16-bits counter] }
    {load the division factor}
    TimebaseReg:=1+32;
    {activate timebase register}
    port[Tp208Address+ContReg[1]]:=TimebaseCon;
    port[Tp208Address+DataReg[1]]:=TimebaseReg;
    port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
    port[Tp208Address+DataReg[1]]:=lo(100);
    port[Tp208Address+DataReg[1]]:=hi(100);
  end;

  if Freq<62 then TimebaseReg:=16+32  {select clck input b}
             else TimebaseReg:=12+32; {select clck input a}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;

end;{SetTimeBase}


{*****************************************************************************}
{******************** SetCalOutput *******************************************}
{*****************************************************************************}
procedure SetCalOutput(var Freq:real;IoAddress:integer);
var DivisionFactor : word;
    InputFreq      : real;
    TimebaseReg    : byte;
    Tp208Address   : word;

begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  InputFreq:=4e6;
  {calculate DivisionFactor}
  if Freq>1e5 then Freq:=1e5;
  DivisionFactor:=round(InputFreq/Freq);
  Freq:=InputFreq/DivisionFactor;

  {initIC 8254, control word A1,A0=11}
  TimebaseReg:=3+32;
  {activate timebase register}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;

  port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
  port[Tp208Address+DataReg[1]]:=182;
                                 {10  [=select counter 2]
                                  11  [=write least significant byte first]
                                  011 [=mode 3, divide by n counter]
                                  0   [=16-bits counter] }
  {load divisionfactor in counter 2}
  TimebaseReg:=2+32;
  {activate timebase register}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;
  port[Tp208Address+ContReg[1]]:=WriteTimebaseCon;
  port[Tp208Address+DataReg[1]]:=lo(DivisionFactor);
  port[Tp208Address+DataReg[1]]:=hi(DivisionFactor);

  TimebaseReg:=3+32;
  {activate timebase register}
  port[Tp208Address+ContReg[1]]:=TimebaseCon;
  port[Tp208Address+DataReg[1]]:=TimebaseReg;
end;{set cal output}


{*****************************************************************************}
{******************** ClearSram **********************************************}
{*****************************************************************************}
procedure ClearSram(IoAddress:integer);
var ch_nr       : integer;
    Freq        : real;
    Tp208Address: word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  {reset trig channel 1}
  port[Tp208Address+ContReg[2]]:=5;
  port[Tp208Address+DataReg[2]]:=0;
  {reset trig channel 2}
  port[Tp208Address+ContReg[3]]:=5;
  port[Tp208Address+DataReg[3]]:=0;
  {set clck source to PC}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;
  SetPostCount(32768+1,IoAddress);
  for ch_nr:=1 to 2 do
  begin
    {set data/zero on zero}
    port[Tp208Address+ContReg[ch_nr+1]]:=4;
    port[Tp208Address+DataReg[ch_nr+1]]:=1;
  end;
  {set fastest timebase}
  Freq:=20e6;
  SetTimebase(Freq,MasterCard);
  {set clck source}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=14;
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {set clck on}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=15;
end;{ClearSram}


{*****************************************************************************}
{******************** GotoSramPos ********************************************}
{*****************************************************************************}
procedure GotoSramPos(Pos,IoAddress:integer);
var Freq         : real;
    Tp208Address : word;

begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  {set clck source to PC}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;
  SetPostCount(Pos,IoAddress);
  Freq:=20e6;
  SetTimebase(Freq,MasterCard);
  {reset post}
  port[Tp208Address+0]:=4;
  port[Tp208Address+1]:=0;
  {set trig on no trig}
  port[Tp208Address+0]:=7;
  port[Tp208Address+1]:=2;
  {set clck source}
  port[Tp208Address+0]:=3;
  port[Tp208Address+1]:=2;
  {set clck on}
  port[Tp208Address+0]:=3;
  port[Tp208Address+1]:=3;

  repeat
  until (port[Tp208Address+2] and 1)=1;

  port[Tp208Address+0]:=3;
  port[Tp208Address+1]:=0;
end;{GotoSramPos}

{*****************************************************************************}
{******************** ReadAddressCounter *************************************}
{*****************************************************************************}
function ReadAddressCounter(IoAddress:integer):word;
var Count        : word;
    Tp208Address : word;
begin
  Case IoAddress of
    MasterCard : Tp208Address:=Tp208AddressMaster;
    SlaveCard1 : Tp208Address:=Tp208AddressSlave1;
    else       exit;
  end;
  {set clck source to PC}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;
  {read address counter}
  Count:=port[Tp208Address+0];
  Count:=port[Tp208Address+1]*256+Count;
  ReadAddressCounter:=Count and 32767;
end;{ReadAddressCounter}

{*****************************************************************************}
{******************** ReadDataSram *******************************************}
{*****************************************************************************}
procedure ReadDataSram(instel : Tp208SettingsType; var Data: MeasureDataArray);
var i             : word;
    SampleNumber  : integer;
    Help_i        : longint;
    CountSlave1,
    Count         : word;
begin
  CountSlave1:=ReadAddressCounter(SlaveCard1);

  Count:=ReadAddressCounter(MasterCard);
  Help_i:=Count-instel.PostSamples-instel.PreSamples;
  if Help_i<0 then Help_i:=Help_i+32767;
  GotoSramPos(Help_i,MasterCard);
  for SampleNumber:=-instel.PreSamples to instel.PostSamples-1 do
  begin
    {Read Data}
    Data[MasterCard][1][SampleNumber]:=port[Tp208AddressMaster+4];
    Data[MasterCard][2][SampleNumber]:=port[Tp208AddressMaster+6];
    {inc address Counter}
    port[Tp208AddressMaster+ContReg[1]]:=5;
    port[Tp208AddressMaster+DataReg[1]]:=0;
  end;
  ClearSram(MasterCard);


  Help_i:=CountSlave1-instel.PostSamples-instel.PreSamples;
  if Help_i<0 then Help_i:=Help_i+32767;
  GotoSramPos(Help_i,SlaveCard1);
  for SampleNumber:=-instel.PreSamples to instel.PostSamples-1 do
  begin
    {Read Data}
    Data[SlaveCard1][1][SampleNumber]:=port[Tp208AddressSlave1+4];
    Data[SlaveCard1][2][SampleNumber]:=port[Tp208AddressSlave1+6];
    {inc address Counter}
    port[Tp208AddressSlave1+ContReg[1]]:=5;
    port[Tp208AddressSlave1+DataReg[1]]:=0;
  end;
  ClearSram(SlaveCard1);
end;{ReadDataSram}


{*****************************************************************************}
{******************** MeasureTp208 ******************************************}
{*****************************************************************************}
procedure MeasureTp208(instel : Tp208SettingsType);
Var Tp208Address : word;
begin
  {set clck source}
  Tp208Address:=Tp208AddressMaster;
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;

  SetTriglevel(instel.TrigHel,instel.TrigLevel,instel.TrigHys,instel.TrigSource,MasterCard);
  SetTimebase (instel.SampleFreq, MasterCard);
  SetPostCount(instel.PostSamples,MasterCard);
  SetPostCount(instel.PostSamples,SlaveCard1);
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {reset trig channel 1}
  port[Tp208Address+ContReg[2]]:=5;
  port[Tp208Address+DataReg[2]]:=0;
  {reset trig channel 2}
  port[Tp208Address+ContReg[3]]:=5;
  port[Tp208Address+DataReg[3]]:=0;

  Tp208Address:=Tp208AddressSlave1;
  port[Tp208Address+ContReg[2]]:=4;
  port[Tp208Address+DataReg[2]]:=0;{clock channel 1 normal}
  port[Tp208Address+ContReg[3]]:=4;
  port[Tp208Address+DataReg[3]]:=0;{clock channel 2 normal}
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {set clck source}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;
  {set trigger source}
  port[Tp208Address+ContReg[1]]:=7;
  port[Tp208Address+DataReg[1]]:=5;{ <--- Crusial instruction: ExtTrig }
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {reset trig channel 1}
  port[Tp208Address+ContReg[2]]:=5;
  port[Tp208Address+DataReg[2]]:=0;
  {reset trig channel 2}
  port[Tp208Address+ContReg[3]]:=5;
  port[Tp208Address+DataReg[3]]:=0;


  Tp208Address := Tp208AddressMaster;
  port[Tp208Address+ContReg[2]]:=4;
  port[Tp208Address+DataReg[2]]:=0;{clock channel 1 normal}
  port[Tp208Address+ContReg[3]]:=4;
  port[Tp208Address+DataReg[3]]:=0;{clock channel 2 normal}
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {set clck source}
  port[Tp208Address+ContReg[1]]:=3;
  port[Tp208Address+DataReg[1]]:=0;
  {set trigger sourse}
  port[Tp208Address+ContReg[1]]:=7;
  case instel.TrigSource of
    Ch1Trig : port[Tp208Address+DataReg[1]]:=0;
    ExtTrig,
    Ch2Trig : port[Tp208Address+DataReg[1]]:=1;
    NoTrig  : port[Tp208Address+DataReg[1]]:=2;
    else      port[Tp208Address+DataReg[1]]:=3;
  end;{case}
  {reset post counter and address counter}
  port[Tp208Address+ContReg[1]]:=4;
  port[Tp208Address+DataReg[1]]:=0;
  {reset trig channel 1}
  port[Tp208Address+ContReg[2]]:=5;
  port[Tp208Address+DataReg[2]]:=0;
  {reset trig channel 2}
  port[Tp208Address+ContReg[3]]:=5;
  port[Tp208Address+DataReg[3]]:=0;

  {set clck sram}
  port[Tp208AddressMaster+ContReg[1]]:=3;
  port[Tp208AddressSlave1+ContReg[1]]:=3;
  port[Tp208AddressSlave1+DataReg[1]]:=15;
  port[Tp208AddressMaster+DataReg[1]]:=15;

end;{MeasureTp208}


{*****************************************************************************}
{************************   MeasureOffsettTp208  *****************************}
{*****************************************************************************}
procedure CalibrateOfsetTp208(CardType:integer);
const OffsetCount   = 50;
      MaxErrorValue = 10;
      OffsetValue   = 10;
var Switch,
    i,
    ChNumber      : integer;
    HelpValue     : longint;
    Tp208Settings : Tp208SettingsType;
    Data          : MeasureDataArray;
    PpgaSwitch    : array[1..2,1..6] of longint;
    OffsetAdHelp  : array[1..2] of real;
begin
  OffsetAdHelp[1]:=OffsetAd[CardType][1];
  OffsetAdHelp[2]:=OffsetAd[CardType][2];
  OffsetAd[CardType][1]:=-2.0*(OffsetValue/256);
  OffsetAd[CardType][2]:=-2.0*(OffsetValue/256);
  PgaSwitch[1][ 1]:=Pga1Gain10+Pga1Gain4;
  PgaSwitch[1][ 2]:=Pga1Gain10+Pga1Gain2;
  PgaSwitch[1][ 3]:=Pga1Gain10+Pga1Gain1;
  PgaSwitch[1][ 4]:=Pga1Gain4;
  PgaSwitch[1][ 5]:=Pga1Gain2;
  PgaSwitch[1][ 6]:=Pga1Gain1;

  PgaSwitch[2][ 1]:=Pga2Gain10+Pga2Gain4+Pga2On;
  PgaSwitch[2][ 2]:=Pga2Gain10+Pga2Gain2+Pga2On;
  PgaSwitch[2][ 3]:=Pga2Gain10+Pga2Gain1+Pga2On;
  PgaSwitch[2][ 4]:=Pga2Gain4+Pga2On;
  PgaSwitch[2][ 5]:=Pga2Gain2+Pga2On;
  PgaSwitch[2][ 6]:=Pga2Gain1+Pga2On;

  for ChNumber:=1 to 2 do
  begin
    for Switch:=1 to 6 do
    begin
      SetRef(ValueRef[CardType][1][Switch],ValueRef[CardType][2][Switch],CardType);
      SetPga(true,true,PgaSwitch[1][Switch]+PgaSwitch[2][Switch]+RefOn,CardType);
      repeat
        case ChNumber of
          1  : begin
                 SetDa(1,ValueDa[CardType][1][Switch]+OffsetAd[CardType][1],CardType);
                 SetDa(2,0,CardType);
               end;
          2  : begin
                 SetDa(1,0,CardType);
                 SetDa(2,ValueDa[CardType][2][Switch]+OffsetAd[CardType][2],CardType);
               end;
        end;{case}
        Tp208Settings.SampleFreq:=4e6;
        Tp208Settings.PostSamples:=OffsetCount+40;
        Tp208Settings.PreSamples:=OffsetCount+40;
        Tp208Settings.TrigHys:=0;
        Tp208Settings.TrigLevel:=128;
        Tp208Settings.TrigHel:=PosSlope;
        Tp208Settings.TrigSource:=NoTrig;
        MeasureTp208(Tp208Settings);
        repeat
        until ReadEoc(MasterCard);
        ReadDataSram(Tp208Settings,Data);
        HelpValue:=0;
        for i:=1 to OffsetCount do HelpValue:=HelpValue+Data[CardType][ChNumber][i];
        if HelpValue>(OffsetValue*OffsetCount)+MaxErrorValue
          then ValueDa[CardType][ChNumber][Switch]:=ValueDa[CardType][ChNumber][Switch]+5/2048;
        if HelpValue<(OffsetValue*OffsetCount)-MaxErrorValue
          then ValueDa[CardType][ChNumber][Switch]:=ValueDa[CardType][ChNumber][Switch]-5/2048;
      until ((HelpValue<=(OffsetValue*OffsetCount)+MaxErrorValue) and
             (HelpValue>=(OffsetValue*OffsetCount)-MaxErrorValue));
    end;
  end;
  for ChNumber:=1 to 2 do
  begin
    ValueDa[CardType][ChNumber][ 7]:=ValueDa[CardType][ChNumber][4];
    ValueDa[CardType][ChNumber][ 8]:=ValueDa[CardType][ChNumber][5];
    ValueDa[CardType][ChNumber][ 9]:=ValueDa[CardType][ChNumber][6];
    ValueDa[CardType][ChNumber][10]:=ValueDa[CardType][ChNumber][4];
    ValueDa[CardType][ChNumber][11]:=ValueDa[CardType][ChNumber][5];
    ValueDa[CardType][ChNumber][12]:=ValueDa[CardType][ChNumber][6];
  end;
  OffsetAd[CardType][1]:=OffsetAdHelp[1];
  OffsetAd[CardType][2]:=OffsetAdHelp[2];
end;{MeasureOffsetTp208}


{*****************************************************************************}
{************************    CalibrateGainTp208       ************************}
{*****************************************************************************}
procedure CalibrateGainTp208(CardType :integer);
const GainNumber=100;
      MaxErrorValue=20;
      MaxValue=250/256;
var HelpValue     : longint;
    Tp208Settings : Tp208SettingsType;
    Data          : MeasureDataArray;
    i,j,
    MeasureValue  : longint;
    PgaSwitch     : array[1..2,1..6] of longint;
    Count,
    ChNumber,
    Switch        : integer;
    CalValue      : real;
begin
  PgaSwitch[1][ 1]:=Pga1Gain10+Pga1Gain4;
  PgaSwitch[1][ 2]:=Pga1Gain10+Pga1Gain2;
  PgaSwitch[1][ 3]:=Pga1Gain10+Pga1Gain1;
  PgaSwitch[1][ 4]:=Pga1Gain4;
  PgaSwitch[1][ 5]:=Pga1Gain2;
  PgaSwitch[1][ 6]:=Pga1Gain1;

  PgaSwitch[2][ 1]:=Pga2Gain10+Pga2Gain4+Pga2On;
  PgaSwitch[2][ 2]:=Pga2Gain10+Pga2Gain2+Pga2On;
  PgaSwitch[2][ 3]:=Pga2Gain10+Pga2Gain1+Pga2On;
  PgaSwitch[2][ 4]:=Pga2Gain4+Pga2On;
  PgaSwitch[2][ 5]:=Pga2Gain2+Pga2On;
  PgaSwitch[2][ 6]:=Pga2Gain1+Pga2On;

  for Switch:=1 to 6 do
  begin
    CalValue:=PgaSwitchValue[Switch]*MaxValue*25;
    if CalValue>4.96093 then CalValue:=4.96093;
    MeasureValue:=round((128+(128*0.04*CalValue/PgaSwitchValue[Switch]))*GainNumber);
    SetDa(1,OffsetAd[CardType][1]+ValueDa[CardType][1][Switch],CardType);
    SetDa(2,CalValue,CardType);
    SetPga(true,true,PgaSwitch[1][Switch]+PgaSwitch[2][Switch]+RefOn,CardType);
    Count:=0;
    repeat
      inc(Count);
      SetRef(ValueRef[CardType][1][Switch],ValueRef[CardType][2][Switch],CardType);
      delay(2);
      Tp208Settings.SampleFreq:=4e6;
      Tp208Settings.PostSamples:=GainNumber+40;
      Tp208Settings.PreSamples:=GainNumber+40;
      Tp208Settings.TrigHys:=0;
      Tp208Settings.TrigLevel:=128;
      Tp208Settings.TrigHel:=PosSlope;
      Tp208Settings.TrigSource:=NoTrig;
      MeasureTp208(Tp208Settings);
      j:=0;
      repeat
      until ReadEoc(MasterCard);
      ReadDataSram(Tp208Settings,Data);
      HelpValue:=0;
      for i:=1 to GainNumber do HelpValue:=HelpValue+Data[CardType][1][i];
      if HelpValue>MeasureValue+MaxErrorValue then inc(ValueRef[CardType][1][Switch]);
      if HelpValue<MeasureValue-MaxErrorValue then dec(ValueRef[CardType][1][Switch]);
    until ((HelpValue<=MeasureValue+MaxErrorValue) and (HelpValue>=MeasureValue-MaxErrorValue))
       or ((ValueRef[CardType][1][Switch]>255) or (ValueRef[CardType][1][Switch]<1))
       or (Count>128);
  end;


  for Switch:=1 to 6 do
  begin
    CalValue:=PgaSwitchValue[Switch]*MaxValue*25;
    if CalValue>4.96093 then CalValue:=4.96093;
    MeasureValue:=round((2048/16+(2048/16*0.04*CalValue/PgaSwitchValue[Switch]))*GainNumber);
    SetDa(1,CalValue,CardType);
    SetDa(2,OffsetAd[CardType][2]+ValueDa[CardType][2][Switch],CardType);
    SetPga(true,true,PgaSwitch[1][Switch]+PgaSwitch[2][Switch]+RefOn,CardType);
    Count:=0;
    repeat
      inc(Count);
      SetRef(ValueRef[CardType][1][Switch],ValueRef[CardType][2][Switch],CardType);
      delay(2);
      Tp208Settings.SampleFreq:=4e6;
      Tp208Settings.PostSamples:=GainNumber+40;
      Tp208Settings.PreSamples:=GainNumber+40;
      Tp208Settings.TrigHys:=0;
      Tp208Settings.TrigHel:=PosSlope;
      Tp208Settings.TrigSource:=NoTrig;
      MeasureTp208(Tp208Settings);
      j:=0;
      repeat
        for i:=1 to 10 do inc(j);
      until ReadEoc(MasterCard);
      ReadDataSram(Tp208Settings,Data);
      HelpValue:=0;
      for i:=1 to GainNumber do HelpValue:=HelpValue+Data[CardType][2][i];
      if HelpValue>MeasureValue+MaxErrorValue then inc(ValueRef[CardType][2][Switch]);
      if HelpValue<MeasureValue-MaxErrorValue then dec(ValueRef[CardType][2][Switch]);
    until ((HelpValue<=MeasureValue+MaxErrorValue) and (HelpValue>=MeasureValue-MaxErrorValue))
       or ((ValueRef[CardType][2][Switch]>255) or (ValueRef[CardType][2][Switch]<1))
       or (Count>128);
  end;

  for ChNumber:=1 to 2 do
  begin
    ValueRef[CardType][ChNumber][ 7]:=ValueRef[CardType][ChNumber][4];
    ValueRef[CardType][ChNumber][ 8]:=ValueRef[CardType][ChNumber][5];
    ValueRef[CardType][ChNumber][ 9]:=ValueRef[CardType][ChNumber][6];
    ValueRef[CardType][ChNumber][10]:=ValueRef[CardType][ChNumber][4];
    ValueRef[CardType][ChNumber][11]:=ValueRef[CardType][ChNumber][5];
    ValueRef[CardType][ChNumber][12]:=ValueRef[CardType][ChNumber][6];
  end;
end;{CalibrateGainTp208}


{*****************************************************************************}
{************************       CalibrateTp208  ******************************}
{*****************************************************************************}
procedure CalibrateTp208(var CalError:boolean;CardType:integer);
var i         : longint;
    ChNumber,
    Switch    : integer;
begin
  SetDa(1,ValueDa[CardType][1][1]+OffsetAd[CardType][1],CardType);
  SetDa(2,ValueDa[CardType][2][1]+OffsetAd[CardType][2],CardType);
  for i:=1 to 2 do
  begin
    CalibrateOfsetTp208(CardType);
    CalibrateGainTp208(CardType);
  end;
  CalibrateOfsetTp208(CardType);
  CalError:=false;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      if (ValueRef[CardType][ChNumber][Switch]<10) or (ValueRef[CardType][ChNumber][Switch]>250) then CalError:=true;
  if CalError then
  begin
    for i:=1 to 2 do
    begin
      CalibrateOfsetTp208(CardType);
      CalibrateGainTp208(CardType);
    end;
    CalibrateOfsetTp208(CardType);
  end;
  CalError:=false;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      if (ValueRef[CardType][ChNumber][Switch]<10) or (ValueRef[CardType][ChNumber][Switch]>250) then CalError:=true;
  ValueDa[CardType][1][ 1]:=ValueDa[CardType][1][1]-40/2048;
  ValueDa[CardType][2][ 1]:=ValueDa[CardType][2][1]-40/2048;
  ValueDa[CardType][1][ 2]:=ValueDa[CardType][1][2]-10/2048;
  ValueDa[CardType][2][ 2]:=ValueDa[CardType][2][2]-10/2048;

end;{calibrateTp208}


{*****************************************************************************}
{************************       HardwarePresent    ***************************}
{*****************************************************************************}
function HardwarePresent:boolean;
var i     : integer;
    Value : integer;
begin
  Value:=0;
  for i:=1 to 10 do Value:=port[Tp208AddressMaster+3]+Value;
  for i:=1 to 10 do Value:=port[Tp208AddressSlave1+3]+Value;
  if Value=0 then HardwarePresent:=true
             else HardwarePresent:=false;
end;


{*****************************************************************************}
{************************       InitTp208          ***************************}
{*****************************************************************************}
procedure InitTp208;
var ChNumber,
    Switch   : integer;
    CalError : boolean;
begin
  for i:=-MaxPreSamples to MaxPostSamples do
  begin
    MeasureData[1][1][i]:=128;
    MeasureData[1][2][i]:=128;
    MeasureData[2][1][i]:=128;
    MeasureData[2][2][i]:=128;
    OldData[1][1][i]:=128;
    OldData[1][2][i]:=128;
    OldData[2][1][i]:=128;
    OldData[2][2][i]:=128;
  end;

  getintvec($1c,Int1cSave);
  setintvec($1c,@TimeOutTimer);
  if not(HardwarePresent) then
  begin
    write(Text2);
    halt(1);
  end;

  PgaSwitch[1][ 1]:=Pga1Gain10+Pga1Gain4+Pga1Att1;
  PgaSwitch[1][ 2]:=Pga1Gain10+Pga1Gain2+Pga1Att1;
  PgaSwitch[1][ 3]:=Pga1Gain10+Pga1Gain1+Pga1Att1;
  PgaSwitch[1][ 4]:=Pga1Gain4+Pga1Att1;
  PgaSwitch[1][ 5]:=Pga1Gain2+Pga1Att1;
  PgaSwitch[1][ 6]:=Pga1Gain1+Pga1Att1;
  PgaSwitch[1][ 7]:=Pga1Gain4+Pga1Att10;
  PgaSwitch[1][ 8]:=Pga1Gain2+Pga1Att10;
  PgaSwitch[1][ 9]:=Pga1Gain1+Pga1Att10;
  PgaSwitch[1][10]:=Pga1Gain4+Pga1Att100;
  PgaSwitch[1][11]:=Pga1Gain2+Pga1Att100;
  PgaSwitch[1][12]:=Pga1Gain1+Pga1Att100;

  PgaSwitch[2][ 1]:=Pga2Gain10+Pga2Gain4+Pga2Att1+Pga2On;
  PgaSwitch[2][ 2]:=Pga2Gain10+Pga2Gain2+Pga2Att1+Pga2On;
  PgaSwitch[2][ 3]:=Pga2Gain10+Pga2Gain1+Pga2Att1+Pga2On;
  PgaSwitch[2][ 4]:=Pga2Gain4+Pga2Att1+Pga2On;
  PgaSwitch[2][ 5]:=Pga2Gain2+Pga2Att1+Pga2On;
  PgaSwitch[2][ 6]:=Pga2Gain1+Pga2Att1+Pga2On;
  PgaSwitch[2][ 7]:=Pga2Gain4+Pga2Att10+Pga2On;
  PgaSwitch[2][ 8]:=Pga2Gain2+Pga2Att10+Pga2On;
  PgaSwitch[2][ 9]:=Pga2Gain1+Pga2Att10+Pga2On;
  PgaSwitch[2][10]:=Pga2Gain4+Pga2Att100+Pga2On;
  PgaSwitch[2][11]:=Pga2Gain2+Pga2Att100+Pga2On;
  PgaSwitch[2][12]:=Pga2Gain1+Pga2Att100+Pga2On;

  PgaSwitchValue[1]:=20e-3;
  PgaSwitchValue[2]:=40e-3;
  PgaSwitchValue[3]:=80e-3;
  PgaSwitchValue[4]:=200e-3;
  PgaSwitchValue[5]:=400e-3;
  PgaSwitchValue[6]:=800e-3;
  PgaSwitchValue[7]:=2;
  PgaSwitchValue[8]:=4;
  PgaSwitchValue[9]:=8;
  PgaSwitchValue[10]:=20;
  PgaSwitchValue[11]:=40;
  PgaSwitchValue[12]:=80;

  ClearSram(MasterCard);
  OffsetAd[MasterCard][1]:=-1.0;
  OffsetAd[MasterCard][2]:=-1.0;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      ValueDa[MasterCard][ChNumber][Switch]:=0.0;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      ValueRef[MasterCard][ChNumber][Switch]:=127;
  calibrateTp208(CalError,MasterCard);
  if CalError then
  begin
    write(Text1);
    halt(1);
  end;

  ClearSram(SlaveCard1);
  OffsetAd[SlaveCard1][1]:=-1.0;
  OffsetAd[SlaveCard1][2]:=-1.0;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      ValueDa[SlaveCard1][ChNumber][Switch]:=0.0;
  for ChNumber:=1 to 2 do
    for Switch:=1 to 12 do
      ValueRef[SlaveCard1][ChNumber][Switch]:=127;

  calibrateTp208(CalError,SlaveCard1);
  if CalError then
  begin
    write(Text1);
    halt(1);
  end;
end;


{*****************************************************************************}
{************************    MeasureTp208          ***************************}
{*****************************************************************************}
procedure StartMeasureTp208(MeasureSetting :MeasureSettingsArray;var MeasureData:MeasureDataArray);
var Tp208Setting    : Tp208SettingsType;
    SwitchSetting   : longint;
begin
  SwitchSetting:=PgaSwitch[1][MeasureSetting[MasterCard].Switch[1]]+PgaSwitch[2][MeasureSetting[MasterCard].Switch[2]];
  SetDa(1,MeasureSetting[MasterCard].DcLevel[1]
         +OffsetAd[MasterCard][1]+ValueDa[MasterCard][1][MeasureSetting[MasterCard].Switch[1]],MasterCard);
  SetDa(2,MeasureSetting[MasterCard].DcLevel[2]
         +OffsetAd[MasterCard][2]+ValueDa[MasterCard][2][MeasureSetting[MasterCard].Switch[2]],MasterCard);
  SetRef(ValueRef[MasterCard][1][MeasureSetting[MasterCard].Switch[1]],
         ValueRef[MasterCard][2][MeasureSetting[MasterCard].Switch[2]],MasterCard);
  SetPga(MeasureSetting[MasterCard].AcDc[Ch1],MeasureSetting[MasterCard].AcDc[Ch2],SwitchSetting,MasterCard);

  SwitchSetting:=PgaSwitch[1][MeasureSetting[SlaveCard1].Switch[1]]+PgaSwitch[2][MeasureSetting[SlaveCard1].Switch[2]];
  SetDa(1,MeasureSetting[SlaveCard1].DcLevel[1]+OffsetAd[SlaveCard1][1]+
          ValueDa[SlaveCard1][1][MeasureSetting[SlaveCard1].Switch[1]],SlaveCard1);
  SetDa(2,MeasureSetting[SlaveCard1].DcLevel[2]+OffsetAd[SlaveCard1][2]+
          ValueDa[SlaveCard1][2][MeasureSetting[SlaveCard1].Switch[2]],SlaveCard1);
  SetRef(ValueRef[SlaveCard1][1][MeasureSetting[SlaveCard1].Switch[1]],
          ValueRef[SlaveCard1][2][MeasureSetting[SlaveCard1].Switch[2]],SlaveCard1);
  SetPga(MeasureSetting[SlaveCard1].AcDc[Ch1],MeasureSetting[SlaveCard1].AcDc[Ch2],SwitchSetting,SlaveCard1);

  Tp208Setting.SampleFreq := MeasureSetting[MasterCard].SampleFreq;
  Tp208Setting.PostSamples:= MeasureSetting[MasterCard].PostSamples;
  Tp208Setting.PreSamples := MeasureSetting[MasterCard].PreSamples;
  Tp208Setting.TrigHys    := MeasureSetting[MasterCard].TrigHys;
  Tp208Setting.TrigLevel  := MeasureSetting[MasterCard].TrigLevel;
  Tp208Setting.TrigHel    := MeasureSetting[MasterCard].TrigHel;
  Tp208Setting.TrigSource := MeasureSetting[MasterCard].TrigSource;
  MeasureTp208(Tp208Setting);

  inline($fa);TimerCount:=0;inline($fb);
  repeat
    if (TimerCount>=MeasureSetting[MasterCard].TimeOut) then SetTrigbit(MasterCard);
  until ReadEoc(MasterCard);

  if ReadEoc(MasterCard) then
  begin
    ReadDataSram(Tp208Setting,MeasureData);
  end;
end;{StartMeasureTp208}