
const
  {text const}
  Text1='Calibration error !';
  Text2='TP208 hardware not found';

  TP208AddressMaster : word=$300;{Base address of the Master card Tp208}
  TP208AddressSlave1 : word=$308;{Base address of the Slave card Tp208}
  MaxCardNr=2;
  MasterCard=1;
  SlaveCard1=2;
  PgaSwitchTime=3;{Delay time for swicthing the relais}

  {Posible Input voltage}
  Pga20mVolt=1;
  Pga40mVolt=2;
  Pga80mVolt=3;
  Pga200mVolt=4;
  Pga400mVolt=5;
  Pga800mVolt=6;
  Pga2Volt=7;
  Pga4Volt=8;
  Pga8Volt=9;
  Pga20Volt=10;
  Pga40Volt=11;
  Pga80Volt=12;

  {Pga settingen for Tp208}
  Pga1Gain2     =2;
  Pga1Gain1     =4;
  Pga1Gain10    =8;
  Pga2Gain10    =16;
  Pga2Gain1     =32;
  Pga2Gain2     =64;
  Pga2Gain4     =128;
  Pga2On        =256;
  Pga1On        =512;
  Pga1Gain4     =1024;
  Pga1Att10     =2048;
  Pga1Att1      =4096;
  Pga1AcDc      =8192;
  Pga2AcDc      =16384;
  Pga2Att1      =32768;
  Pga2Att10     =65536;
  Pga2Att100    =131072;
  RefOn         =524288;
  Pga1Att100    =1048576;

  {Settings constans}
  CoupleAC      = true;
  CoupleDC      = false;
  PosSlope      = true;
  NegSlope      = false;
  Ch1Trig       = 1;
  Ch2Trig       = 2;
  NoTrig        = 3;
  ExtTrig       = 4;
  CH1           = 1;
  CH2           = 2;

  {CONTROL registers and Data registers}
  ContReg  : array[1..3] of byte =(0,4,6);
  DataReg  : array[1..3] of byte =(1,5,7);

  {Value for CONTROL registers}
  PostLoCon        = 0;
  PostHiCon        = 1;
  TimebaseCon      = 2;
  WriteTimebaseCon = 6;
  Level1ConAd      : array[1..2] of byte =(0,0);
  Level2ConAd      : array[1..2] of byte =(1,1);
  TrigLevelConAd   : array[1..2] of byte =(2,2);
  Level1RegAd      : array[1..2] of byte =(0,0);
  Level2RegAd      : array[1..2] of byte =(0,0);
  TrigLevelRegAd   : array[1..2] of byte =(0,0);

  {Maximun Pre and Post samples}
  MaxPreSamples=2000;
  MaxPostSamples=2000;

type
  Tp208SettingsType = record
                         SampleFreq : real;
                         PostSamples : longint;
                         PreSamples : longint;
                         TrigLevel  : byte;
                         TrigHys    : byte;
                         TrigHel    : boolean;
                         TrigSource : byte;
                       end;
  MeasureDataType = array[1..2,-MaxPreSamples..MaxPostSamples] of byte;
  MeasureSettingsType = record
                          Switch     : array[1..2] of byte;
                          DcLevel    : array[1..2] of real;
                          AcDc       : array[1..2] of boolean;
                          SampleFreq : real;
                          PreSamples : integer;
                          PostSamples: integer;
                          TrigLevel  : byte;
                          TrigHys    : byte;
                          TrigHel    : boolean;
                          TrigSource : integer;
                          TimeOut    : longint;
                        end;
  MeasureSettingsArray = array[1..MaxCardNr] of MeasureSettingsType;
  MeasureDataArray = array[1..MaxCardNr] of MeasureDataType;
 var
  {For TP208}
  PgaSwitch      : array[1..2,1..12] of longint;
  PgaSwitchValue : array[1..12] of real;
  OffsetAd       : array[1..MaxCardNr,1..2] of real;
  ValueRef       : array[1..MaxCardNr,1..2,1..12] of byte;
  ValueDa        : array[1..MaxCardNr,1..2,1..12] of real;

  {For program}
  MeasureSetting : MeasureSettingsArray;
  MeasureData    : MeasureDataArray;
  OldData        : MeasureDataArray;
  x,i            : integer;
  TimerCount     : longint;
  ExitSave,
  Int1cSave      : pointer;
  GraphDriver    : integer;
  GraphMode      : integer;
  Errorcode      : integer;
  Offset         : integer;